<template>
  <i-wrapper top>
    <i-header :title="$t(`Planetary transits`)" :back="{ name: 'today' }" />
    <i-curtain :bottom-circles="false" scrollable fixed>
      <div class="container d-flex flex-column align-items-center">
        <div class="p-title">{{ planetaryTransit.title }}</div>
        <div class="p-description">{{ planetaryTransit.description }}</div>
        <div ref="map" class="p-map"></div>
        <div class="p-separator mt-4 mb-4" />
        <div class="p-subtitle">
          {{ $t(`Transiting`) }} {{ $t(`planetNames.${planetaryTransit.firstPlanetName.toLowerCase()}`) }}
          {{ planetaryTransit.transitHouseTextIn }}
        </div>
        <i-progress-bar
          class="mt-1"
          :height="25"
          :percentage="planetaryTransit.progress * 100"
          :text-left="planetaryTransit.transitionDateString"
          gray-background
          :text-center="planetaryTransit.progress > 0 ? null : $t('Has not yet started')" />
        <div class="p-separator mt-4 mb-4" />
        <div class="p-subdescription mb-4">
          {{
            $t(
              `{firstPlanet} is now {degrees}°({position}) away from the place where {secondPlanet} was when you were born.`,
              {
                firstPlanet: this.$t(`planetNames.${planetaryTransit.firstPlanetName.toLowerCase()}`),
                degrees: planetaryTransit.directionDegrees,
                position: this.$t(planetaryTransit.planetPosition),
                secondPlanet: this.$t(`planetNames.${planetaryTransit.secondPlanetName.toLowerCase()}`),
              }
            )
          }}
        </div>
      </div>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import * as d3 from 'd3';
  import ordinalNumber from '~/utils/ordinal-number.js';

  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],
    transition: { name: 'fade', mode: 'out-in' },

    async asyncData({ $axios, redirect, params, store }) {
      let response = await $axios.get('pages/today');

      let planetaryTransit = response.data.data.planetaryTransits.find((planetaryTransit) => {
        return planetaryTransit.id === params.planetaryTransitId;
      });

      if (!planetaryTransit) {
        return redirect({ name: 'today' });
      }

      if (!store.state.auth.user.hasActiveSubscription) {
        return redirect({ name: 'today' });
      }

      return { planetaryTransit };
    },

    mounted() {
      this.drawMap(this.planetaryTransit);
    },

    methods: {
      ordinalNumber,

      getPlanetImagePath(planetName) {
        planetName = planetName.toLowerCase();
        let postfix = `${planetName}-w2${planetName === 'sun' ? '-variant-1' : ''}`;
        return require(`~/assets/images/planet-${postfix}.svg`);
      },

      drawMap(planetaryTransit) {
        let size = 240;
        let labelsOffset = 12;
        let labelsOffsetBack = 3;
        let earthSize = 65;
        let normalPlanetSize = 27;
        let bigPlanetSize = 36;
        let distanceArrowSize = 16.2;
        let distanceArcOffset = 13;
        let sectorTextOffset = -19.6;

        let svg = d3
          .select(this.$refs.map)
          .append('svg')
          .attr('width', '100%')
          .attr('height', '100%')
          .attr('viewBox', `0 0 ${size + labelsOffset * 2} ${size + labelsOffset * 2}`);

        let arc1 = d3
          .arc()
          .innerRadius(0)
          .outerRadius(size / 2 - 0.8)
          .startAngle(-((planetaryTransit.fillSectors.planetsAngles[0] - 90) * Math.PI) / 180)
          .endAngle(-((planetaryTransit.fillSectors.planetsAngles[1] - 90) * Math.PI) / 180);

        svg
          .append('path')
          .attr('class', 'arc')
          .attr('d', arc1)
          .attr('fill', '#F3F3F3')
          .attr(
            'transform',
            `translate(${labelsOffset + (size - 2) / 2 + 1}, ${labelsOffset + (size - 2) / 2 + 1}) rotate(${
              planetaryTransit.rotationOffset
            } 0 0)`
          );

        for (let angle of planetaryTransit.anglesOfAstrologicalHouses) {
          svg
            .append('line')
            .style('stroke', '#ddc4ca')
            .style('stroke-width', 0.5)
            .attr(
              'x1',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * -Math.cos(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            )
            .attr(
              'y1',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * -Math.sin(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            )
            .attr(
              'x2',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * Math.cos(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            )
            .attr(
              'y2',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * Math.sin(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            );
        }

        for (let circleIndex = 0; circleIndex < 4; ++circleIndex) {
          if (circleIndex === 0) {
            continue;
          }

          let circleSize = (size / 4) * (circleIndex + 1);

          svg
            .append('circle')
            .attr('cx', labelsOffset + (size - 2) / 2 + 1)
            .attr('cy', labelsOffset + (size - 2) / 2 + 1)
            .attr('r', (circleSize - 2) / 2)
            .style('fill', 'transparent')
            .style('stroke', circleIndex === 3 ? '#961937' : '#ddc4ca')
            .style('stroke-width', circleIndex === 3 ? 1 : 0.5);
        }

        for (let angle of planetaryTransit.degreesBetweenHousesAngles) {
          let angleIndex = planetaryTransit.degreesBetweenHousesAngles.indexOf(angle);

          svg
            .append('text')
            .attr('x', 0)
            .attr('y', 0)
            .attr('fill', '#000000')
            .attr('text-anchor', 'middle')
            .attr('dominant-baseline', 'central')
            .style('font-size', '55%')
            .attr(
              'transform',
              `translate(
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + labelsOffset - labelsOffsetBack) *
                    Math.cos(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + labelsOffset - labelsOffsetBack) *
                    Math.sin(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
              ) rotate(${
                (angle - planetaryTransit.rotationOffset + 3600) % 360 >= 180
                  ? -angle - 90 + planetaryTransit.rotationOffset
                  : -angle + 90 + planetaryTransit.rotationOffset
              } 0 0)`
            )
            .text(() => angleIndex + 1);
        }

        let arcRadius = (size / 2 / 4) * (planetaryTransit.distanceBetweenAngles.bigRadius ? 3 : 2);

        svg
          .append('image')
          .attr('href', require(`~/assets/images/distance-between-planets-arrow.svg`))
          .attr('x', -distanceArrowSize / 2)
          .attr('y', -distanceArrowSize / 2 - 2)
          .attr('width', distanceArrowSize)
          .attr('height', distanceArrowSize)
          .attr(
            'transform',
            `translate(${
              labelsOffset +
              (size - 2) / 2 +
              1 +
              (arcRadius - 0.8) *
                Math.cos(
                  ((-planetaryTransit.distanceBetweenAngles.planetsAngles[1] +
                    distanceArcOffset +
                    planetaryTransit.rotationOffset) *
                    Math.PI) /
                    180
                )
            } ${
              labelsOffset +
              (size - 2) / 2 +
              1 +
              (arcRadius - 0.8) *
                Math.sin(
                  ((-planetaryTransit.distanceBetweenAngles.planetsAngles[1] +
                    distanceArcOffset +
                    planetaryTransit.rotationOffset) *
                    Math.PI) /
                    180
                )
            }) rotate(${
              -planetaryTransit.distanceBetweenAngles.planetsAngles[1] +
              distanceArcOffset +
              planetaryTransit.rotationOffset +
              180
            } 0 0)`
          );

        let arc0 = d3
          .arc()
          .innerRadius(arcRadius - 0.8)
          .outerRadius(arcRadius)
          .startAngle(
            -(
              (planetaryTransit.distanceBetweenAngles.planetsAngles[0] - 90 - planetaryTransit.rotationOffset) *
              Math.PI
            ) / 180
          )
          .endAngle(
            -(
              (planetaryTransit.distanceBetweenAngles.planetsAngles[1] -
                90 -
                distanceArcOffset -
                planetaryTransit.rotationOffset) *
              Math.PI
            ) / 180
          );

        svg
          .append('path')
          .attr('class', 'arc')
          .attr('d', arc0)
          .attr('fill', '#961937')
          .attr('transform', `translate(${labelsOffset + (size - 2) / 2 + 1}, ${labelsOffset + (size - 2) / 2 + 1})`);

        svg
          .append('image')
          .attr('href', require(`~/assets/images/planet-earth-w1.svg`))
          .attr('width', earthSize)
          .attr('height', earthSize)
          .attr('x', labelsOffset + (size - 2) / 2 + 1 - earthSize / 2)
          .attr('y', labelsOffset + (size - 2) / 2 + 1 - earthSize / 2);

        for (let drawPlanet of planetaryTransit.drawPlanets) {
          let drawPlanetSize = drawPlanet.isBig ? bigPlanetSize : normalPlanetSize;
          let drawPlanetRadius = (size / 4) * (drawPlanet.bigRadius ? 3 : 2);

          svg
            .append('image')
            .attr('width', drawPlanetSize)
            .attr('height', drawPlanetSize)
            .attr(
              'x',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((drawPlanetRadius - 2) / 2) *
                  Math.cos(((-drawPlanet.angle + planetaryTransit.rotationOffset) * Math.PI) / 180) -
                drawPlanetSize / 2
            )
            .attr(
              'y',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((drawPlanetRadius - 2) / 2) *
                  Math.sin(((-drawPlanet.angle + planetaryTransit.rotationOffset) * Math.PI) / 180) -
                drawPlanetSize / 2
            )
            .attr('href', this.getPlanetImagePath(drawPlanet.name));
        }

        let sectorTextAngle =
          (planetaryTransit.fillSectors.planetsAngles[0] + planetaryTransit.fillSectors.planetsAngles[1]) / 2;

        svg
          .append('text')
          .attr('x', 0)
          .attr('y', 0)
          .attr('fill', '#961937')
          .attr('text-anchor', 'middle')
          .attr('dominant-baseline', 'central')
          .style('font-size', '55%')
          .text(() => `${planetaryTransit.directionDegrees}°`)
          .attr(
            'transform',
            `translate(
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + sectorTextOffset) *
                    Math.cos(((-sectorTextAngle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + sectorTextOffset) *
                    Math.sin(((-sectorTextAngle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
              ) rotate(${
                (sectorTextAngle - planetaryTransit.rotationOffset + 3600) % 360 >= 180
                  ? -sectorTextAngle - 90 + planetaryTransit.rotationOffset
                  : -sectorTextAngle + 90 + planetaryTransit.rotationOffset
              } 0 0)`
          );
      },
    },
  };
</script>

<style lang="scss" scoped>
  .p-title {
    width: 100%;
    color: #524c62;
    font-size: rf(16px);
    line-height: 140%;
    font-weight: bold;
  }

  .p-description {
    font-size: rf(14px);
    line-height: 140%;
    margin-top: rs(5px);
  }

  .p-map {
    width: rs(289px);
    margin-top: rs(15px);
  }

  .p-separator {
    width: 100%;
    height: 1px;
    background-color: rgba(65, 109, 141, 0.3);
    opacity: 0.7;
  }

  .p-subtitle {
    font-size: rs(16px);
    font-weight: bold;
    color: #524c62;
    text-align: center;
  }

  .p-subdescription {
    font-size: rs(14px);
    color: #524c62;
    line-height: 140%;
  }
</style>
